SystemOrganization addCategory: #FuelTestsCompatibilityBeforePharo40!

!MethodContext methodsFor: '*FuelTestsCompatibilityBeforePharo40' stamp: 'MaxLeske 3/22/2015 09:27'!
assertWellMaterializedInto: aMethodContext in: aTestCase

	aTestCase assert: self ~~ aMethodContext. 
	aTestCase assert: (self class == aMethodContext class).
	aTestCase assert: self tempNames = aMethodContext  tempNames.
	aTestCase assert: pc = aMethodContext pc.
	aTestCase assert: stackp = aMethodContext stackPtr.
	closureOrNil isNil 
		ifTrue: [ aTestCase assert: aMethodContext closure isNil ]
		ifFalse: [ closureOrNil assertWellMaterializedInto: aMethodContext closure in: aTestCase ].
	aTestCase assert: receiver = aMethodContext receiver.
	aTestCase assert: (method isEqualRegardlessTrailerTo: aMethodContext method).
	sender isNil 
		ifTrue: [ aTestCase assert: aMethodContext sender isNil ]
		ifFalse: [ sender assertWellMaterializedInto: aMethodContext sender in: aTestCase ]! !

!MethodContext methodsFor: '*FuelTestsCompatibilityBeforePharo40' stamp: 'MaxLeske 3/22/2015 09:27'!
initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	pc := aPc.
	stackp := aStackPtr.
	method := aMethod.
	receiver := aReceiver.
	sender := aSender.
	! !

!FLSerializationTest methodsFor: '*FuelTestsCompatibilityBeforePharo40' stamp: 'MarianoMartinezPeck 4/19/2012 19:40'!
cleanUpTraits

	Smalltalk globals allTraits 
		select: [ :aTrait | aTrait name beginsWith: self traitNamePrefix ]
		thenDo: [ :aTrait | self removeFromSystem: aTrait ]! !

!FLSerializationTest methodsFor: '*FuelTestsCompatibilityBeforePharo40' stamp: 'MarianoMartinezPeck 4/19/2012 19:13'!
newTraitSuffixed: suffix

	^ Trait 
		named: (self traitNamePrefix, suffix) asSymbol
		uses: Array new 
		category: (self classFactory packageName, '-', self classFactory defaultCategoryPostfix) asSymbol! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforePharo40' stamp: 'MaxLeske 3/22/2015 09:28'!
testContext
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforePharo40' stamp: 'MaxLeske 3/22/2015 09:28'!
testContextWithClosureAndSender
	"This test should be improved"
	| context1  materializedContext2  context2 |
	
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
	
	context2 := self class blockClosureContextTestingWithSender: context1.
	materializedContext2 := self resultOfSerializeAndMaterialize: context2.
	context2 assertWellMaterializedInto: materializedContext2 in: self.
	
! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforePharo40' stamp: 'MaxLeske 3/22/2015 09:28'!
testContextWithNilPc
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: nil 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforePharo40' stamp: 'MaxLeske 3/22/2015 09:29'!
testContextWithSender
	"This test should be improved"
	| context1 context2 materializedContext1 |
	context1 := (MethodContext newForMethod: FLPair >> #method1).
	context1 
		initializeWith: 23 
		stackPtr: 1 
		method: FLPair >> #method1 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
		
	context2 := (MethodContext newForMethod: FLPair >> #method2).
	context2 
		initializeWith: 18 
		stackPtr: 1 
		method: FLPair >> #method2 
		receiver:  (FLPair new right: 5; left: 6) 
		sender: nil.

	context1 privSender:  context2.
		
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !

!FLContextSerializationTest methodsFor: '*FuelTestsCompatibilityBeforePharo40' stamp: 'MaxLeske 3/22/2015 09:28'!
testContextWithTemp
	"This test should be improved"
	| context1  materializedContext1  |
	context1 := (MethodContext newForMethod: FLPair >> #methodWithTemp).
	context1 
		initializeWith: nil 
		stackPtr: 1 
		method: FLPair >> #methodWithTemp 
		receiver:  (FLPair new right: 4; left: 2) 
		sender: nil.
	context1 tempNamed: 'string' put: 'capo'.
	
	materializedContext1 := self resultOfSerializeAndMaterialize: context1.
	self assert: (materializedContext1 tempNamed: 'string') = 'capo'.
	context1 assertWellMaterializedInto: materializedContext1 in: self.! !
